/*
*	Java Source Code for fast 2D true color animation and games
*	yov408 Technologies Production - http://www.yov408.com
*	Memory Image Source Buffering
*	** Most of the code taken from JavaHelp.com **
*/

import java.awt.*;
import java.awt.event.*;
import java.awt.image.MemoryImageSource;

public class FullScreenMemoryImageSource {

	public static void junk( Ray R )
	{
		double crap[] = new double[1];
		for (int j = 0; j < 180; ++j) crap[0] = 0;
		//Math.abs(4); Math.abs(4);
		//Math.sqrt(4);
		new Collision(R, 1, null); //new Collision(R, 2, null);
		double garbage[] = new double[4];
		//Vector4D V = new Vector4D();
		//for (int i = 0; i < 4; ++i) V.elem[i] = i;
		//V.normalize();
	}

	public static void main(String[] argv){

		int divisor =
			argv.length > 0
			? Integer.valueOf(argv[0]).intValue()
			: 1;

		boolean casse_toi=false;


		GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
		GraphicsDevice gd = ge.getDefaultScreenDevice();
	
	   	Frame frame = new Frame(gd.getDefaultConfiguration());
    	Window win = new Window(frame);
    
		win.addMouseListener(new MouseAdapter() {
        	public void mousePressed(MouseEvent evt) {
	            GraphicsDevice gd = GraphicsEnvironment.getLocalGraphicsEnvironment()
    	            .getDefaultScreenDevice();
        	    gd.setFullScreenWindow(null);
				System.exit(0);
        	}
    	});

    
    	try {
	        
       	gd.setFullScreenWindow(win);
       	win.requestFocus();

 		DisplayMode[] affichages = gd.getDisplayModes();
		int i;
		for(i=0;i<affichages.length;i++){
			if((affichages[i].getWidth()==1025)&&(affichages[i].getHeight()==768)&&(affichages[i].getBitDepth()==32)){
				gd.setDisplayMode(affichages[i]);
			}
		}

       	int screenWidth = win.getWidth();
       	int screenHeight = win.getHeight();

		Graphics graphicwindow = win.getGraphics();
		graphicwindow.setColor(Color.black);
       	graphicwindow.fillRect(0,0,screenWidth,screenHeight);

   	    int size = screenWidth * screenHeight;
		int[] pixels = new int[size];

	    MemoryImageSource source = new MemoryImageSource(screenWidth, screenHeight, pixels, 0, screenWidth);
	    source.setAnimated(true);
	    source.setFullBufferUpdates(true);
		Image offscreen = Toolkit.getDefaultToolkit().createImage(source);

		graphicwindow.setClip(0, 0, 1024, 768/divisor);

		int frames=0;
		long lastTime = System.currentTimeMillis();
		Camera cam = new Camera();
		Ray R = new Ray(cam, 0, 0);

		while(!casse_toi){
			
			frames++;
			// junk to take up time.
		    for (i = 0; i < size/divisor; i++) {
				pixels[i] = 0xffff0000;
				junk(R);
	   		}

	   		source.newPixels(0, 0, 1024, 768/divisor);
			graphicwindow.drawImage(offscreen,0,0,null); 

			long t = System.currentTimeMillis();
			if (t - lastTime >= 1000) {
				String s = "fps " + 1000.0*frames/(t-lastTime);
				graphicwindow.setColor(Color.black);
	 			graphicwindow.drawString(s,20,20);
			}
		}


    	}
		catch (Throwable e)
		{
        
    	}

	}


}
