/*
 *  This file is part of Dascant.
 *
 *  Dascant is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Dascant is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Dascant; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301
 *  USA
 */

#ifndef _DASCANT_CUCUMBER
#define _DASCANT_CUCUMBER

#include "quadric.h"
#include "vector4.h"

class cucumber : public quadric {
private:
	void initialize(const vector4 *);
public:
	vector4 size;
	cucumber(double);
	cucumber(const vector4 *);
	cucumber(double, double, double, double);
	cucumber(void);
	cucumber &operator()(const vector4 *);
#if 0
	virtual int detectCollisions(const ray *R, collision *) const;
#endif
};

#endif
