public class test_DSML_Lexer {
	public static void main( String argv[] )
	{
		DSML_Token tok;

		if (argv.length == 0) {
			System.err.println("usage: java test_DSML_Lexer filename");
			System.exit(1);
		}

		try {
			DSML_Lexer lex = new DSML_Lexer(argv[0]);
			System.out.println("DSML version " + lex.version);
			while ((tok=lex.nextToken()) != null)
				System.out.println(tok.toString());
		}
		catch (Exception e) { System.err.println(e.getMessage()); }
	}
};
