public class test_Rotation4D {
	public static void main( String argv[] )
	{
		Vector4D P = new Vector4D();
		Rotation4D R=null;
		int i;

		if (argv.length < 2) {
			System.err.println(
				"usage: java test_Rotation4D axis1 axis2 point");
			System.exit(1);
		}

		try {
			R = new Rotation4D(
				Rotation4D.toAxis(argv[0]),
				Rotation4D.toAxis(argv[1])); 
		} catch(Exception e) {
			System.out.println(e.getMessage());
			System.exit(1);
		}

		for (i = 0; i < 4; ++i)
			if (argv.length > i + 2)
				P.elem[i] = (new Double(argv[i+2]).doubleValue());

		System.out.println("P = " + P.toString() + "\n");

		System.out.println("R = \n" + R.toString() + "\n");

		Vector4D Q = R.applyTo(Math.PI/2, P);
		System.out.println("R P = " + Q.toString());
	}
};
