public class test_crossprod {
	public static void main( String argv[] )
	{
		if (argv.length < 12) {
			System.err.println("usage: java test_crossprod V1 V2 V3");
			System.exit(1);
		}

		Vector4D V[] = new Vector4D[4];
		int i, j;

		for (i = 0; i < 3; ++i) {
			V[i] = new Vector4D();
			for (j = 0; j < 4; ++j)
				V[i].elem[j] = Integer.valueOf(argv[j+4*i].intValue());
		}

		V[3] = V[0].cross(V[1], V[2]);

		for (i = 0; i < 4; ++i)
			System.out.println("V[" + i + "] = " + V[i].toString());
	}
};
